%define oname RsyncUI

Name: rsyncui
Summary: Client for rsync server
Version: 1.8.5
Release: %mkrel 1
License: GPLv3
Group: Networking/Remote access
Source0: %{oname}-%{version}.tar.gz
Packager: dtux@free.fr
Distribution: Mageia
Url: https://www.librepc.fr
Vendor: DTux
BuildRequires:      qmake
BuildRequires:      make
BuildRequires:      pkgconfig(Qt5Core)
BuildRequires:      pkgconfig(Qt5Gui)
BuildRequires:      pkgconfig(Qt5Concurrent)
BuildRequires:      pkgconfig(Qt5Widgets)
BuildRequires:      pkgconfig(Qt5Xml)
BuildRequires:      pkgconfig(libmagic)
BuildRequires:      cmake(KF5Completion)
BuildRequires:      cmake(KF5CoreAddons)
BuildRequires:      cmake(KF5I18n)
BuildRequires:      cmake(KF5DBusAddons)
BuildRequires:      cmake(KF5Config)
BuildRequires:      cmake(KF5ItemViews)
BuildRequires:      pstreams-devel
BuildRequires:      boost-devel

#Requires:       kitemviews
#Requires:       kcompletion
#Requires:       kcoreaddons
#Requires:       kdbusaddons
Requires:       rsync
Requires:       bind-utils

%global debug_package %{nil}

%description
RsyncUI can connect to an rsync server, get the list of services,
and download files.

%prep
%setup -q  -n %{oname}

%build
%make_build

%install
#INSTALL_ROOT=%{BUILDROOT} make install

mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_datadir}/applications/
mkdir -p %{buildroot}%{_datadir}/icons/
install -p -m 755 %{oname} %{buildroot}%{_bindir}/%{oname}
install -p -m 644 %{oname}.desktop %{buildroot}%{_datadir}/applications/
install -p -m 644 %{oname}.png  %{buildroot}%{_datadir}/icons/

pushd languages
for locale in *;
do
	mkdir -p %{buildroot}%{_datadir}/locale/$locale/LC_MESSAGES
	install -m 644 $locale/*.qm "%{buildroot}%{_datadir}/locale/$locale/LC_MESSAGES/"
done
popd
%find_lang %{oname} --with-qt

%files -f %{oname}.lang
%{_bindir}/%{oname}
%{_datadir}/applications/%{oname}.desktop
%{_datadir}/icons/%{oname}.png
